"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EntryPlugin = void 0;
const base_1 = require("./base");
exports.EntryPlugin = (0, base_1.create)(base_1.BuiltinPluginName.EntryPlugin, (context, entry, options) => {
    return {
        context,
        entry,
        options: getRawEntryOptions(options)
    };
});
function getRawEntryOptions(entry) {
    const runtime = entry.runtime;
    const chunkLoading = entry.chunkLoading;
    return {
        name: entry.name,
        publicPath: entry.publicPath,
        baseUri: entry.baseUri,
        runtime: runtime === false ? undefined : runtime,
        chunkLoading: chunkLoading === false ? "false" : chunkLoading,
        asyncChunks: entry.asyncChunks,
        filename: entry.filename
    };
}
