"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SwcJsMinimizerRspackPlugin = void 0;
const base_1 = require("./base");
function getRawSwcJsMinimizerRule(condition) {
    if (typeof condition === "string") {
        return {
            type: "string",
            stringMatcher: condition
        };
    }
    if (condition instanceof RegExp) {
        return {
            type: "regexp",
            regexpMatcher: condition.source
        };
    }
    throw new Error("unreachable: condition should be one of string, RegExp");
}
function getRawSwcJsMinimizerRules(condition) {
    if (!condition)
        return undefined;
    if (Array.isArray(condition)) {
        return {
            type: "array",
            arrayMatcher: condition.map(i => getRawSwcJsMinimizerRule(i))
        };
    }
    return getRawSwcJsMinimizerRule(condition);
}
exports.SwcJsMinimizerRspackPlugin = (0, base_1.create)(base_1.BuiltinPluginName.SwcJsMinimizerRspackPlugin, (options) => {
    var _a, _b, _c, _d, _e, _f;
    return {
        passes: (_a = options === null || options === void 0 ? void 0 : options.passes) !== null && _a !== void 0 ? _a : 1,
        dropConsole: (_b = options === null || options === void 0 ? void 0 : options.dropConsole) !== null && _b !== void 0 ? _b : false,
        keepClassNames: (_c = options === null || options === void 0 ? void 0 : options.keepClassNames) !== null && _c !== void 0 ? _c : false,
        keepFnNames: (_d = options === null || options === void 0 ? void 0 : options.keepFnNames) !== null && _d !== void 0 ? _d : false,
        pureFuncs: (_e = options === null || options === void 0 ? void 0 : options.pureFuncs) !== null && _e !== void 0 ? _e : [],
        comments: (options === null || options === void 0 ? void 0 : options.comments) ? options.comments : "false",
        asciiOnly: (_f = options === null || options === void 0 ? void 0 : options.asciiOnly) !== null && _f !== void 0 ? _f : false,
        extractComments: (options === null || options === void 0 ? void 0 : options.extractComments)
            ? String(options.extractComments)
            : undefined,
        test: getRawSwcJsMinimizerRules(options === null || options === void 0 ? void 0 : options.test),
        include: getRawSwcJsMinimizerRules(options === null || options === void 0 ? void 0 : options.include),
        exclude: getRawSwcJsMinimizerRules(options === null || options === void 0 ? void 0 : options.exclude)
    };
});
