"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = exports.RspackBuiltinPlugin = exports.BuiltinPluginName = void 0;
// TODO: workaround for https://github.com/napi-rs/napi-rs/pull/1690
var BuiltinPluginName;
(function (BuiltinPluginName) {
    BuiltinPluginName["DefinePlugin"] = "DefinePlugin";
    BuiltinPluginName["ProvidePlugin"] = "ProvidePlugin";
    BuiltinPluginName["BannerPlugin"] = "BannerPlugin";
    BuiltinPluginName["ProgressPlugin"] = "ProgressPlugin";
    BuiltinPluginName["EntryPlugin"] = "EntryPlugin";
    BuiltinPluginName["ExternalsPlugin"] = "ExternalsPlugin";
    BuiltinPluginName["NodeTargetPlugin"] = "NodeTargetPlugin";
    BuiltinPluginName["ElectronTargetPlugin"] = "ElectronTargetPlugin";
    BuiltinPluginName["HttpExternalsRspackPlugin"] = "HttpExternalsRspackPlugin";
    BuiltinPluginName["CopyRspackPlugin"] = "CopyRspackPlugin";
    BuiltinPluginName["HtmlRspackPlugin"] = "HtmlRspackPlugin";
    BuiltinPluginName["SwcJsMinimizerRspackPlugin"] = "SwcJsMinimizerRspackPlugin";
    BuiltinPluginName["SwcCssMinimizerRspackPlugin"] = "SwcCssMinimizerRspackPlugin";
})(BuiltinPluginName = exports.BuiltinPluginName || (exports.BuiltinPluginName = {}));
class RspackBuiltinPlugin {
    apply(compiler) {
        compiler.__internal__registerBuiltinPlugin(this);
    }
}
exports.RspackBuiltinPlugin = RspackBuiltinPlugin;
function create(name, resolve) {
    return class Plugin extends RspackBuiltinPlugin {
        constructor(...args) {
            var _a;
            super();
            this.name = name;
            this._options =
                (_a = resolve(...args)) !== null && _a !== void 0 ? _a : false /* undefined or null will cause napi error, so false for fallback */;
        }
        raw() {
            return {
                name: name,
                options: this._options
            };
        }
    };
}
exports.create = create;
